package com.simpleinventory.app.fragment;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Locale;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import com.simpleinventory.app.R;
import com.simpleinventory.app.helper.PrintTask;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class SetInfo extends Fragment implements OnClickListener {

    private static final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd", Locale.ENGLISH);
    public static final String ARG_ITEM_ID = "inventory_fragment";
    String whichInterface ="";
    EditText ad;
    TextView addesc;
    Spinner dropdown1=null;
    Spinner dropdown2=null;
    Spinner dropdown3=null;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        View rootView = inflater.inflate(R.layout.set_info, container, false);

        dropdown1 = rootView.findViewById(R.id.spinner1);
        String[] items1 = new String[]{"tcpip", "bluetooth"};
        ArrayAdapter<String> adapter1 = new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_dropdown_item, items1);
        dropdown1.setAdapter(adapter1);

        dropdown2 = rootView.findViewById(R.id.spinner2);
        String[] item2 = new String[]{"status3", "status3_lapin", "status4"};
        ArrayAdapter<String> adapter2 = new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_dropdown_item, item2);
        dropdown2.setAdapter(adapter2);

        dropdown3 = rootView.findViewById(R.id.spinner3);
        String[] item3 = new String[]{"false", "true"};
        ArrayAdapter<String> adapter3 = new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_dropdown_item, item3);
        dropdown3.setAdapter(adapter3);

        ad = (EditText) rootView.findViewById(R.id.addressField);
        addesc = (TextView) rootView.findViewById(R.id.addressfld);

      ///////Differentiating between bluetooth and the tcpip as we need it to play withthe UI and to know what to save later, Damo
            PrintTask.variableMap = null;//must be a null as the null is for port acqiring,Damo
            PrintTask.isPortSet=false;
            new PrintTask(getActivity()).execute(""); //very important point, we canll the smartPri class here, Damo

            if(PrintTask.resultFinal!=null)
            {
                for(int i=0; i<PrintTask.resultFinal.size(); i++)
                {
                  if(PrintTask.resultFinal.keySet().toArray()[i].toString().trim().equals("deviceType"))
                  {
                      TextView txtview = rootView.findViewById(R.id.addressfld);

                      if(PrintTask.resultFinal.values().toArray()[i].toString().trim().equals("tcpip")) {
                          dropdown1.setSelection(0);
                          whichInterface = "tcpip";
                          txtview.setText("IP Address");
                      }
                      else
                      {
                          dropdown1.setSelection(1);
                          whichInterface = "bluetooth";
                          txtview.setText("BT Address");
                      }
                  }

                  if(PrintTask.resultFinal.keySet().toArray()[i].toString().trim().equals("protocol"))
                  {
                        if(PrintTask.resultFinal.values().toArray()[i].toString().trim().equals("status3"))
                            dropdown2.setSelection(0);
                        else if(PrintTask.resultFinal.values().toArray()[i].toString().trim().equals("status3_lapin"))
                            dropdown2.setSelection(1);
                        else if(PrintTask.resultFinal.values().toArray()[i].toString().trim().equals("status4"))
                            dropdown2.setSelection(2);
                  }

                  if(PrintTask.resultFinal.keySet().toArray()[i].toString().trim().equals("crc"))
                  {
                        if(PrintTask.resultFinal.values().toArray()[i].toString().trim().equals("false"))
                            dropdown3.setSelection(0);
                        else
                            dropdown3.setSelection(1);
                  }
                    if(PrintTask.resultFinal.keySet().toArray()[i].toString().trim().equals("address"))
                    {
                        if(PrintTask.resultFinal.get("deviceType").trim().equals("tcpip"))
                            ad.setText(PrintTask.resultFinal.values().toArray()[i].toString().trim().substring(0,PrintTask.resultFinal.values().toArray()[i].toString().length()-5)); //Displaying of the addres  without the port at the end as that form can be saved and it's easier to validate later, Damo
                       else
                            ad.setText(PrintTask.resultFinal.values().toArray()[i].toString().trim());

                    }

                }
            }
            else
            {
                Toast toast = Toast.makeText(getActivity(), "No Data Acquired In Set Data", Toast.LENGTH_SHORT);
                toast.show();
            }
        //////

        rootView.findViewById(R.id.stockInBtn).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v)
            {
                SendSBPL stockInFragment  = new SendSBPL();
                switchContent(stockInFragment, "send_SBPL");
                // PrintItem();
            }
        });

        rootView.findViewById(R.id.stockOutBtn).setOnClickListener(
                new OnClickListener() {
                    @Override
                    public void onClick(View v)
                    {

                        GetInfo stockOutFragment  = new GetInfo();
                        switchContent(stockOutFragment, "get_info");
                    }
                });

        rootView.findViewById(R.id.InventoryBtn).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v)
            {
                SetInfo stockInv  = new SetInfo();
                switchContent(stockInv, "set_info");
            }
        });

        rootView.findViewById(R.id.setData).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v)
            {

                if(!ad.getText().toString().trim().equals(""))
                {

                    String addr=ad.getText().toString().trim();

                    if(whichInterface.equals("tcpip"))
                    {
                        if(isValidIP(addr))
                            setData();
                        else
                        {
                            Toast toast1 = Toast.makeText(getActivity(), "IP Address is in a wrong format", Toast.LENGTH_SHORT);
                            toast1.show();
                        }
                    }

                    if(whichInterface.equals("bluetooth"))
                    {
                        if(isValidBT(addr))
                            setData();
                        else
                        {
                            Toast toast1 = Toast.makeText(getActivity(), "Bluetooth Address is in a wrong format", Toast.LENGTH_SHORT);
                            toast1.show();
                        }
                    }
                }
                else {
                    Toast toast1 = Toast.makeText(getActivity(), "The IP/BT Address Field Is Compulsory", Toast.LENGTH_SHORT);
                    toast1.show();
                }
            }
        });

        dropdown1.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l)
            {
                if(dropdown1.getSelectedItem().toString().equals("tcpip"))
                {
                    whichInterface="tcpip";
                    addesc.setText("IP Address");
                }
                 else
                {
                    whichInterface="bluetooth";
                    addesc.setText("BT Address");
                }
            }

        public void onNothingSelected(AdapterView<?> adapterView)
        {
            return;
        }
    });

        return rootView;
    }

    public static Boolean isValidIP(String input)
    {
        if (input!= null && !input.isEmpty())
        {

            String regex = "^((25[0-5])|(2[0-4]\\d)|(1\\d\\d)|([1-9]\\d)|\\d)(\\.((25[0-5])|(2[0-4]\\d)|(1\\d\\d)|([1-9]\\d)|\\d)){3}$";

            if (input.matches(regex))
                return true;
             else
                return false;

        }
        // invalid input
        return false;
    }

    public static boolean isValidBT(String macAddr)
    {
        if (macAddr!= null && !macAddr.isEmpty())
        {
            Pattern ptn1 = Pattern.compile("^([a-fA-F0-9]{2}[:\\.-]?){5}[a-fA-F0-9]{2}$");
            Pattern ptn2 = Pattern.compile("^([a-fA-F0-9]{3}[:\\.-]?){3}[a-fA-F0-9]{3}$");
            Pattern ptn3 = Pattern.compile("^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$");

            Matcher mtch1 = ptn1.matcher(macAddr);
            Matcher mtch2 = ptn2.matcher(macAddr);
            Matcher mtch3 = ptn3.matcher(macAddr);

            return (mtch1.find() || mtch2.find() || mtch3.find());
        }
        return false;
    }

    private String base64Encode(String comm) {
        String encString = "";

        try {
            byte[] encodeValue = android.util.Base64.encode(comm.getBytes(), android.util.Base64.URL_SAFE);
            encString = new String(encodeValue);
        } catch (Exception e) {
            Toast toast = Toast.makeText(getActivity(), "Error In Encoding", Toast.LENGTH_SHORT);
            toast.show();
            e.printStackTrace();
        }
        return encString;
    }

    private void setData()
    {
              PrintTask.variableMap = new HashMap<String, String>();
              PrintTask.isPortSet=true;

              PrintTask.variableMap.put("__device_type", dropdown1.getSelectedItem().toString().trim());
              PrintTask.variableMap.put("__address", ad.getText().toString().trim());
              PrintTask.variableMap.put("__protocol", dropdown2.getSelectedItem().toString().trim());
              PrintTask.variableMap.put("__crc", dropdown3.getSelectedItem().toString().trim());

              new PrintTask(getActivity()).execute("dummy");
    }


    public void switchContent(Fragment fragment, String tag)
    {
        FragmentManager fragmentManager = getActivity().getSupportFragmentManager();;
        while (fragmentManager.popBackStackImmediate());

        if(fragment != null)
        {
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(R.id.content_frame, fragment, tag);
            transaction.addToBackStack(tag);
            transaction.commit();
        }
    }

    private void messageDisplay(String message)
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setCancelable(false);
        builder.setMessage(message);
        builder.setNegativeButton(android.R.string.ok,
                new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id)
                    {
                        dialog.cancel();
                    }
                });
        builder.create().show();
    }

    @Override
    public void onResume()
    {
        super.onResume();
    }

    @Override
    public void onSaveInstanceState(Bundle outState)
    {

    }

    @Override
    public void onClick(View view)
    {

    }

}
